// Licensed to Apache Software Foundation (ASF) under one or more contributor
// license agreements. See the NOTICE file distributed with
// this work for additional information regarding copyright
// ownership. Apache Software Foundation (ASF) licenses this file to you under
// the Apache License, Version 2.0 (the "License"); you may
// not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.

package profiling

import (
	"github.com/apache/skywalking-rover/pkg/module"
	continuousBase "github.com/apache/skywalking-rover/pkg/profiling/continuous/base"
	taskBase "github.com/apache/skywalking-rover/pkg/profiling/task/base"
)

type Config struct {
	module.Config `mapstructure:",squash"`

	CheckInterval string `mapstructure:"check_interval"` // Check the profiling task interval
	FlushInterval string `mapstructure:"flush_interval"` // Flush profiling data interval

	TaskConfig       *taskBase.TaskConfig             `mapstructure:"task"`       // Profiling task config
	ContinuousConfig *continuousBase.ContinuousConfig `mapstructure:"continuous"` // Continuous profiling config
}
